#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys, os

#-------------------------------------------------------------------------------
def win():
    if 'nt' in os.name.lower() or 'win' in os.name.lower():
        return True
    else:
        return False

#-------------------------------------------------------------------------------
def mac():
    if 'darwin' in sys.platform.lower():
        return True
    else:
        return False

#-------------------------------------------------------------------------------
def utf(obj, encoding='utf-8'):
    if isinstance(obj, basestring):
        if not isinstance(obj, unicode):
            obj = unicode(obj, encoding)
    return obj

#-------------------------------------------------------------------------------

# Some logs to inform us about exceptions in the program
ERROR     = []
F_FOUND   = False
F_DEFAULT = True
F_MATCH   = True
USE_PROXY    = False
PROXY_SERVER = ""
PROXY_PORT   = ""

# default font size
SIZE      = 8
FONT_FACE = u"Verdana"
FONT      = None
FONT_B    = None

#Operating system constants
ENC       = None
DIR       = None

#Operating system constants
ENC = sys.getfilesystemencoding()

#TODO: This might create troubles depending on paths
if not ENC:
    if win():
        ENC = "mbcs"
    else:
        ENC = "utf-8"
    ERROR.append(u"getfilesystemencoding is None - using " + ENC)

if getattr(sys, 'frozen', None):
    DIR = utf(sys._MEIPASS + os.sep, ENC)
else:
    DIR = utf(os.path.dirname(os.path.abspath(__file__)) + os.sep, ENC)

os.environ["PATH"] += utf(os.pathsep + DIR + u'lib').encode(ENC)
