#!/usr/bin/python
# -*- coding: utf-8 -*-

import os

import wx
import wx.grid
import wizard
import const

def create(parent):
    return Wizard_s2(parent)

[
    wxID_WIZARD_S2, wxID_WIZARD_S2TABLE_DATA, wxID_WIZARD_S2TOP_PANEL,
    wxID_WIZARD_S2STAT_PANEL, wxID_WIZARD_S1BT_LOG, wxID_WIZARD_S1BT_SEND,
    wxID_WIZARD_S1PROGRESS_BAR, wxID_WIZARD_S1LB_FILES, wxID_WIZARD_S1TXT_FILES,
    wxID_WIZARD_S1LB_FOLDERS, wxID_WIZARD_S1TXT_FOLDERS,
    wxID_WIZARD_S2BUTTONS_PANEL, wxID_WIZARD_S2BOTTOM_PANEL,
    wxID_WIZARD_S1LB_BYTES, wxID_WIZARD_S1TXT_BYTES, wxID_WIZARD_S1LB_LINK1,
    wxID_WIZARD_S1LB_LINK2
] = [wx.NewId() for _init_ctrls in range(17)]

MSG1=u"This is a summary of what will be sent - View the full log for details."
MSG2=u"While the program run you can help further by filling " + \
        "up a survey at:"

class Wizard_s2(wx.Panel):
    def _init_ctrls(self, prnt):
        wx.Panel.__init__(self, id=wxID_WIZARD_S2, name=u'Wizard2', parent=prnt,
            pos=wx.Point(339, 146), size=wx.Size(600, 380))
        self.SetBackgroundColour(wx.Colour(240, 240, 240))
        self.SetClientSize(wx.Size(600, 380))

        self.top_panel = wx.Panel(id=wxID_WIZARD_S2TOP_PANEL, name=u'top_panel',
            parent=self, pos=wx.Point(0, 0), size=wx.Size(600, 260),
            style=wx.NO_BORDER)
        self.top_panel.SetBackgroundColour(wx.Colour(240, 240, 240))

        self.lb_top = wx.StaticText(id=wxID_WIZARD_S1LB_BYTES, label = MSG1,
            name=u'lb_top', parent=self.top_panel, size=wx.Size(600, 20),
            pos=wx.Point(0, 0))
        self.lb_top.SetFont(const.FONT_B)
        self.lb_top.SetForegroundColour(wx.Colour(0, 51, 102))

        self.table_base = wizard.GenericTable()

        self.table_data = wx.grid.Grid(id=wxID_WIZARD_S2TABLE_DATA,
            name=u'table_data', parent=self.top_panel, pos=wx.Point(0, 20),
            style=wx.SIMPLE_BORDER)
        self.table_data.SetTable(self.table_base)
        self.table_data.EnableEditing(False)
        self.table_data.SetDefaultRowSize(14+const.SIZE)
        self.table_data.SetDefaultColSize(60)
        self.table_data.SetColLabelSize(20)
        self.table_data.SetRowLabelSize(0)
        self.table_data.SetDefaultCellFont(const.FONT)
        self.table_data.SetColSize(0, 50)
        self.table_data.SetColSize(1, 130)
        self.table_data.SetColSize(2, 170)
        self.table_data.SetColSize(3, 45)
        self.table_data.SetColSize(4,
            585-(wx.SystemSettings.GetMetric(wx.SYS_HSCROLL_Y)+395))
        self.table_data.SetScrollLineX(1)
        self.table_data.SetGridLineColour(wx.Colour(240, 240, 240))
        self.table_data.SetLabelBackgroundColour(wx.Colour(240, 240, 240))
        self.table_data.SetSelectionBackground(wx.Colour(255, 255, 255))
        self.table_data.SetSelectionForeground(wx.Colour(0, 0, 0))
        self.table_data.SetDefaultCellBackgroundColour(wx.Colour(255, 255, 255))
        self.table_data.ForceRefresh()

        sizer_top = wx.BoxSizer(wx.VERTICAL)
        sizer_top.Add(self.lb_top, 0, wx.ALIGN_LEFT | wx.ALIGN_TOP)
        sizer_top.Add(self.table_data, 1, wx.EXPAND)
        self.top_panel.SetSizer(sizer_top)

        self.bottom_panel = wx.Panel(id=wxID_WIZARD_S2BOTTOM_PANEL,
            name=u'bottom_panel', parent=self, pos=wx.Point(0, 280),
            size=wx.Size(600, 120), style=wx.NO_BORDER)
        self.bottom_panel.SetBackgroundColour(wx.Colour(240, 240, 240))

        self.stat_panel = wx.Panel(id=wxID_WIZARD_S2STAT_PANEL,
            name=u'stat_panel', parent=self.bottom_panel,
            pos=wx.Point(0, 0), size=wx.Size(600, 40), style=wx.SIMPLE_BORDER)
        self.stat_panel.SetBackgroundColour(wx.Colour(240, 240, 240))

        self.lb_files = wx.StaticText(id=wxID_WIZARD_S1LB_FILES,
            label=u'Files:', name=u'lb_files', parent=self.stat_panel,
            size=wx.Size(50, 15))
        self.lb_files.SetFont(const.FONT_B)
        self.lb_files.SetForegroundColour(wx.Colour(0, 51, 102))

        self.txt_files = wx.StaticText(id=wxID_WIZARD_S1TXT_FILES,
            label=u'0', name=u'txt_files', parent=self.stat_panel,
            size=wx.Size(60, 15))
        self.txt_files.SetFont(const.FONT)

        self.lb_folders = wx.StaticText(id=wxID_WIZARD_S1LB_FOLDERS,
            label=u'Folders:', name=u'lb_folders', parent=self.stat_panel,
            size=wx.Size(70, 15))
        self.lb_folders.SetFont(const.FONT_B)
        self.lb_folders.SetForegroundColour(wx.Colour(0, 51, 102))

        self.txt_folders = wx.StaticText(id=wxID_WIZARD_S1TXT_FOLDERS,
            label=u'0', name=u'txt_folders', parent=self.stat_panel,
            size=wx.Size(60, 15))
        self.txt_folders.SetFont(const.FONT)

        self.lb_bytes = wx.StaticText(id=wxID_WIZARD_S1LB_BYTES,
            label=u'Size:', name=u'lb_bytes', parent=self.stat_panel,
            size=wx.Size(45, 15))
        self.lb_bytes.SetFont(const.FONT_B)
        self.lb_bytes.SetForegroundColour(wx.Colour(0, 51, 102))

        self.txt_bytes = wx.StaticText(id=wxID_WIZARD_S1TXT_BYTES,
            label=u'0', name=u'txt_bytes', parent=self.stat_panel,
            size=wx.Size(60, 15))
        self.txt_bytes.SetFont(const.FONT)

        self.progress_bar = wx.Gauge(id=wxID_WIZARD_S1PROGRESS_BAR,
            name=u'progress_bar', parent=self.stat_panel,
            pos=wx.Point(370, 0), size=wx.Size(200, 20),
            style=wx.NO_BORDER | wx.GA_HORIZONTAL)
        self.Bind(wx.EVT_TIMER, self.TimerHandler)
        self.timer = wx.Timer(self)
        self.timer.Start(100)

        sizer_stat = wx.BoxSizer(wx.HORIZONTAL)
        sizer_stat.Add(self.lb_files, 0,
            wx.ALIGN_CENTER_VERTICAL | wx.BOTTOM | wx.TOP | wx.LEFT,
            border = 5)
        sizer_stat.Add(self.txt_files, 0,
            wx.ALIGN_CENTER_VERTICAL | wx.BOTTOM | wx.TOP, border = 5)
        sizer_stat.Add(self.lb_folders, 0,
            wx.ALIGN_CENTER_VERTICAL | wx.BOTTOM | wx.TOP, border = 5)
        sizer_stat.Add(self.txt_folders, 0,
            wx.ALIGN_CENTER_VERTICAL | wx.BOTTOM | wx.TOP, border = 5)
        sizer_stat.Add(self.lb_bytes, 0,
            wx.ALIGN_CENTER_VERTICAL | wx.BOTTOM | wx.TOP, border = 5)
        sizer_stat.Add(self.txt_bytes, 0,
            wx.ALIGN_CENTER_VERTICAL | wx.BOTTOM | wx.TOP, border = 5)
        sizer_stat.Add(self.progress_bar, 1, wx.ALIGN_CENTER_VERTICAL |
            wx.EXPAND | wx.BOTTOM | wx.TOP | wx.RIGHT,
            border = 5)
        self.stat_panel.SetSizer(sizer_stat)

        self.lb_link_1 = wx.StaticText(id=wxID_WIZARD_S1LB_LINK1, label=MSG2,
            name=u'lb_link_1', parent=self.bottom_panel, size=wx.Size(600, 20),
            pos=wx.Point(0, 0))
        self.lb_link_1.SetFont(wx.Font(const.SIZE, wx.SWISS, wx.NORMAL,
            wx.BOLD, False, const.FONT_FACE))
        self.lb_link_1.SetForegroundColour(wx.Colour(0, 51, 102))

        self.lb_link_2 = wx.HyperlinkCtrl(id=wxID_WIZARD_S1LB_LINK2,
            label=u"http://netlab.ice.ufjf.br/form.php",
            url=u"http://netlab.ice.ufjf.br/form.php",
            name=u'lb_link_2', parent=self.bottom_panel, size=wx.Size(500, 20),
            pos=wx.Point(0, 0))
        self.lb_link_2.SetFont(wx.Font(const.SIZE+4, wx.SWISS, wx.NORMAL,
            wx.BOLD, False, const.FONT_FACE))

        self.buttons_panel = wx.Panel(id=wxID_WIZARD_S2BUTTONS_PANEL,
            name=u'buttons_panel ', parent=self.bottom_panel,
            pos=wx.Point(0, 50), size=wx.Size(600, 70), style=wx.NO_BORDER)
        self.buttons_panel.SetBackgroundColour(wx.Colour(240, 240, 240))

        self.bt_log = wx.lib.buttons.GenBitmapTextButton(bitmap=wx.Bitmap(
            const.DIR + 'icons' + os.sep + 'view-list-text.png'),
            id=wxID_WIZARD_S1BT_LOG, label=u' View full log',
            name=u'bt_log', parent=self.buttons_panel, pos=wx.Point(60, 0),
            size=wx.Size(200, 40), style=wx.SIMPLE_BORDER)
        self.bt_log.SetBackgroundColour(wx.Colour(212, 212, 255))
        self.bt_log.SetFont(const.FONT_B)
        self.bt_log.SetForegroundColour(wx.Colour(60, 60, 60))
        self.bt_log.SetHelpText(u'View log before sending it')
        self.bt_log.Bind(wx.EVT_BUTTON, prnt.show_log)
        self.bt_log.Disable()

        self.bt_send = wx.lib.buttons.GenBitmapTextButton(
            bitmap=wx.Bitmap(const.DIR + 'icons' + os.sep + 'arrow-right.png'),
            id=wxID_WIZARD_S1BT_SEND, label=u' Send it!',
            name=u'bt_send', parent=self.buttons_panel, pos=wx.Point(340, 0),
            size=wx.Size(200, 40), style=wx.SIMPLE_BORDER)
        self.bt_send.SetBackgroundColour(wx.Colour(212, 212, 255))
        self.bt_send.SetFont(wx.Font(const.SIZE+4, wx.SWISS, wx.NORMAL,
            wx.BOLD, False, const.FONT_FACE))
        self.bt_send.SetForegroundColour(wx.Colour(60, 60, 60))
        self.bt_send.SetHelpText(u'Finish the experiment')
        self.bt_send.Bind(wx.EVT_BUTTON, prnt.send_it)
        self.bt_send.Disable()

        sizer_botton = wx.BoxSizer(wx.VERTICAL)
        sizer_botton.Add(self.stat_panel, 0,
            wx.ALIGN_CENTER_HORIZONTAL | wx.EXPAND | wx.ALL, border = 0)
        sizer_botton.Add(self.buttons_panel, 1,
            wx.ALIGN_CENTER_HORIZONTAL | wx.EXPAND | wx.ALL, border = 5)
        sizer_botton.Add(self.lb_link_1, 0,
            wx.ALIGN_CENTER_VERTICAL | wx.EXPAND | wx.ALL, border = 0)
        sizer_botton.Add(self.lb_link_2, 0,
            wx.ALIGN_CENTER_HORIZONTAL | wx.EXPAND | wx.ALL, border = 0)
        self.bottom_panel.SetSizer(sizer_botton)

        sizer_all = wx.BoxSizer(wx.VERTICAL)
        sizer_all.Add(self.top_panel, 1,
            wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_TOP | wx.EXPAND | wx.ALL,
            border = 5)
        sizer_all.Add(self.bottom_panel, 0,
            wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_TOP | wx.EXPAND | wx.ALL,
            border = 5)
        self.SetSizer(sizer_all)
        self.Layout()

    def TimerHandler(self, event):
        self.progress_bar.Pulse()

    def __init__(self, parent):
        self._init_ctrls(parent)
