#!/usr/bin/python
# -*- coding: utf-8 -*-

import os

import wx
import wx.lib.buttons
import const
import wizard

def create(parent):
    return Wizard_s3(parent)

[
  wxID_WIZARD_S3, wxID_WIZARD_S3BT_EXIT,
  wxID_WIZARD_S3BT_RETRY,
  wxID_WIZARD_S3THANKS_PANEL, wxID_WIZARD_S3IMAGE_OK,
  wxID_WIZARD_S3ERROR_PANEL, wxID_WIZARD_S3IMAGE_ERROR,
  wxID_WIZARD_S3LB_LINK, wxID_WIZARD_S3LB_MESSAGE_0,
  wxID_WIZARD_S3LB_MESSAGE_1, wxID_WIZARD_S3LB_MESSAGE_2,
  wxID_WIZARD_S3LB_MESSAGE_3, wxID_WIZARD_S3LB_MESSAGE_4,
  wxID_WIZARD_S3LB_MESSAGE_5, wxID_WIZARD_S3LB_MESSAGE_6,
  wxID_WIZARD_S3LB_MESSAGE_7, wxID_WIZARD_S3LB_MESSAGE_8,
  wxID_WIZARD_S3TOP_PANEL, wxID_WIZARD_S3BOTTOM_PANEL,
  wxID_WIZARD_S3LB_PROXY, wxID_WIZARD_S3CHECK_BOX,
  wxID_WIZARD_S3PROXY_PANEL, wxID_WIZARD_S3LB_PROXY_SERVER,
  wxID_WIZARD_S3LB_PROXY_PORT, wxID_WIZARD_S3TXT_PROXY_SERVER,
  wxID_WIZARD_S3TXT_PROXY_PORT,
] = [wx.NewId() for _init_ctrls in range(26)]

class Wizard_s3(wx.Panel):
    def _init_ctrls(self, prnt):
        wx.Panel.__init__(self, id=wxID_WIZARD_S3, name=u'Wizard3', parent=prnt,
            pos=wx.Point(288, 87), size=wx.Size(600, 380), style=0)
        self.SetBackgroundColour(wx.Colour(240, 240, 240))
        self.SetClientSize(wx.Size(600, 380))
        self.parent = prnt

        self.top_panel = wx.Panel(id=wxID_WIZARD_S3TOP_PANEL, name=u'top_panel',
            parent=self, pos=wx.Point(0, 0), style=wx.SIMPLE_BORDER)
        self.top_panel.SetBackgroundColour(wx.Colour(240, 240, 240))

        self.thanks_panel = wx.Panel(id=wxID_WIZARD_S3THANKS_PANEL,
            name=u'thanks_panel', parent=self.top_panel)
        self.thanks_panel.SetBackgroundColour(wx.Colour(240, 240, 240))

        self.image_ok = wx.StaticBitmap(id=wxID_WIZARD_S3IMAGE_OK,
            parent=self.thanks_panel,
            bitmap=wx.BitmapFromImage(
                wx.Image(const.DIR + 'icons' + os.sep + 'dialog-ok-apply.png')))

        self.lb_message_7 = wx.StaticText(id=wxID_WIZARD_S3LB_MESSAGE_7,
            label=u'Thank you!',
            name=u'lb_message_7', parent=self.thanks_panel)
        self.lb_message_7.SetFont(wx.Font(const.SIZE+4, wx.SWISS, wx.NORMAL,
            wx.BOLD, False, const.FONT_FACE))
        self.lb_message_7.SetForegroundColour(wx.Colour(0, 51, 102))

        sizer_thanks = wx.BoxSizer(wx.HORIZONTAL)
        sizer_thanks.AddStretchSpacer(prop=1)
        sizer_thanks.Add(self.image_ok, 1,
            flag=wx.ALIGN_RIGHT | wx.ALIGN_CENTER_VERTICAL | wx.ALL, border=5)
        sizer_thanks.Add(self.lb_message_7, 1,
            flag=wx.ALIGN_LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ALL, border=5)
        sizer_thanks.AddStretchSpacer(prop=1)
        self.thanks_panel.SetSizer(sizer_thanks)

        self.error_panel = wx.Panel(id=wxID_WIZARD_S3ERROR_PANEL,
            name=u'error_panel', parent=self.top_panel)
        self.error_panel.SetBackgroundColour(wx.Colour(240, 240, 240))

        self.image_error = wx.StaticBitmap(id=wxID_WIZARD_S3IMAGE_ERROR,
            parent=self.error_panel,
            bitmap=wx.BitmapFromImage(wx.Image(
                const.DIR + 'icons' + os.sep + 'application-exit.png')))

        self.lb_message_8 = wx.StaticText(id=wxID_WIZARD_S3LB_MESSAGE_8,
            label=u'Something went wrong! ',
            name=u'lb_message_8', parent=self.error_panel)
        self.lb_message_8.SetFont(wx.Font(const.SIZE+4, wx.SWISS, wx.NORMAL,
            wx.BOLD, False, const.FONT_FACE))
        self.lb_message_8.SetForegroundColour(wx.Colour(0, 51, 102))

        sizer_error = wx.BoxSizer(wx.HORIZONTAL)
        sizer_error.AddStretchSpacer(prop=1)
        sizer_error.Add(self.image_error, 0,
            flag=wx.ALIGN_RIGHT | wx.ALIGN_CENTER_VERTICAL | wx.ALL, border=5)
        sizer_error.Add(self.lb_message_8, 0,
            flag=wx.ALIGN_LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ALL, border=5)
        sizer_error.AddStretchSpacer(prop=1)
        self.error_panel.SetSizer(sizer_error)
        self.error_panel.Hide()

        self.lb_link = wx.HyperlinkCtrl(id=wxID_WIZARD_S3LB_LINK,
            label=u"Click to see how your Dropbox folder looks like!",
            url=u"",
            name=u'lb_link', parent=self.top_panel, size=wx.Size(500, 20))
        self.lb_link.SetFont(wx.Font(const.SIZE+4, wx.SWISS, wx.NORMAL,
            wx.BOLD, False, const.FONT_FACE))

        self.lb_message_0 = wx.StaticText(id=wxID_WIZARD_S3LB_MESSAGE_0,
            label=u'You can contact us at:',
            name=u'lb_message_0', parent=self.top_panel)
        self.lb_message_0.SetFont(const.FONT_B)
        self.lb_message_0.SetForegroundColour(wx.Colour(0, 51, 102))

        self.lb_message_1 = wx.StaticText(id=wxID_WIZARD_S3LB_MESSAGE_1,
            label=u'Alex Borges <alex.borges@ufjf.edu.br>',
            name=u'lb_message_1', parent=self.top_panel)
        self.lb_message_1.SetFont(const.FONT)

        self.lb_message_2 = wx.StaticText(id=wxID_WIZARD_S3LB_MESSAGE_2,
            label=u'Universidade Federal de Juiz de Fora',
            name=u'lb_message_2', parent=self.top_panel)
        self.lb_message_2.SetFont(const.FONT)

        self.lb_message_3 = wx.StaticText(id=wxID_WIZARD_S3LB_MESSAGE_3,
            label=u'Idilio Drago <i.drago@utwente.nl>',
            name=u'lb_message_3', parent=self.top_panel)
        self.lb_message_3.SetFont(const.FONT)

        self.lb_message_4 = wx.StaticText(id=wxID_WIZARD_S3LB_MESSAGE_4,
            label=u'University of Twente',
            name=u'lb_message_4', parent=self.top_panel)
        self.lb_message_4.SetFont(const.FONT)

        self.lb_message_5 = wx.StaticText(id=wxID_WIZARD_S3LB_MESSAGE_5,
            label=u'Marco Mellia <mellia@tlc.polito.it>',
            name=u'lb_message_5', parent=self.top_panel)
        self.lb_message_5.SetFont(const.FONT)

        self.lb_message_6 = wx.StaticText(id=wxID_WIZARD_S3LB_MESSAGE_6,
            label=u'Politecnico di Torino',
            name=u'lb_message_6', parent=self.top_panel)
        self.lb_message_6.SetFont(const.FONT)

        sizer_labels = wx.GridSizer(3, 2, 5, 5)
        sizer_labels.AddMany([
            (self.lb_message_1, 0, wx.ALIGN_LEFT  | wx.ALL, 5),
            (self.lb_message_2, 0, wx.ALIGN_RIGHT | wx.ALL, 5),
            (self.lb_message_3, 0, wx.ALIGN_LEFT  | wx.ALL, 5),
            (self.lb_message_4, 0, wx.ALIGN_RIGHT | wx.ALL, 5),
            (self.lb_message_5, 0, wx.ALIGN_LEFT  | wx.ALL, 5),
            (self.lb_message_6, 0, wx.ALIGN_RIGHT | wx.ALL, 5),
        ])

        sizer_top = wx.BoxSizer(wx.VERTICAL)
        sizer_top.Add(self.thanks_panel, 1,
            flag=wx.EXPAND | wx.ALIGN_BOTTOM)
        sizer_top.Add(self.error_panel, 1,
            flag=wx.EXPAND | wx.ALIGN_BOTTOM)
        sizer_top.Add(self.lb_message_0, 0,
            flag=wx.EXPAND | wx.ALIGN_BOTTOM | wx.ALL, border=5)
        sizer_top.Add(sizer_labels, 0,
            flag=wx.EXPAND | wx.ALIGN_BOTTOM | wx.BOTTOM | wx.RIGHT | wx.LEFT ,
            border=10)
        sizer_top.Add(self.lb_link, 0,
            flag=wx.EXPAND | wx.ALIGN_BOTTOM | wx.BOTTOM | wx.RIGHT | wx.LEFT ,
            border=10)
        self.top_panel.SetSizer(sizer_top)

        self.proxy_panel = wx.Panel(id=wxID_WIZARD_S3PROXY_PANEL,
            name=u'proxy_panel', parent=self,
            size=wx.Size(600, 30), style=wx.NO_BORDER | wx.TAB_TRAVERSAL)
        self.proxy_panel.SetBackgroundColour(wx.Colour(240, 240, 240))

        self.cb_proxy = wx.CheckBox(id=wxID_WIZARD_S3CHECK_BOX,
            name=u'cb_proxy', parent=self.proxy_panel)
        self.cb_proxy.Bind(wx.EVT_CHECKBOX, self.cb_proxy_cli)

        self.lb_proxy = wx.StaticText(id=wxID_WIZARD_S3LB_PROXY,
            label=u'Set a proxy manually', name=u'lb_proxy',
            parent=self.proxy_panel)
        self.lb_proxy.SetForegroundColour(wx.Colour(0, 51, 102))
        self.lb_proxy.SetFont(const.FONT_B)
        self.lb_proxy.Bind(wx.EVT_LEFT_DOWN, self.cb_proxy_cli_text)

        self.lb_proxy_server = wx.StaticText(id=wxID_WIZARD_S3LB_PROXY_SERVER,
            label=u'Server: ', name=u'lb_proxy_server', parent=self.proxy_panel)
        self.lb_proxy_server.SetFont(const.FONT)

        self.txt_proxy_server = wx.TextCtrl(id=wxID_WIZARD_S3TXT_PROXY_SERVER,
            name=u'txt_proxy_server', parent=self.proxy_panel,
            size=wx.Size(170, 22))
        self.txt_proxy_server.SetFont(const.FONT)

        self.lb_proxy_port = wx.StaticText(id=wxID_WIZARD_S3LB_PROXY_PORT,
            label=u'Port: ', name=u'lb_proxy_port', parent=self.proxy_panel)
        self.lb_proxy_port.SetFont(const.FONT)

        self.txt_proxy_port = wx.TextCtrl(id=wxID_WIZARD_S3TXT_PROXY_PORT,
            name=u'txt_proxy_port', parent=self.proxy_panel,
            size=wx.Size(40, 22))
        self.txt_proxy_port.SetFont(const.FONT)

        sizer_proxy = wx.BoxSizer(wx.HORIZONTAL)
        sizer_proxy.Add(self.cb_proxy, 0,
            wx.ALIGN_CENTER | wx.LEFT | wx.RIGHT, border = 10)
        sizer_proxy.Add(self.lb_proxy, 0,
            wx.ALIGN_CENTER | wx.RIGHT, border = 10)
        sizer_proxy.Add(self.lb_proxy_server, 0,
            wx.ALIGN_CENTER | wx.LEFT, border = 10)
        sizer_proxy.Add(self.txt_proxy_server, 0,
            wx.ALIGN_CENTER | wx.LEFT, border = 10)
        sizer_proxy.Add(self.lb_proxy_port, 0,
            wx.ALIGN_CENTER | wx.LEFT, border = 10)
        sizer_proxy.Add(self.txt_proxy_port, 0,
            wx.ALIGN_CENTER | wx.LEFT, border = 10)
        self.proxy_panel.SetSizer(sizer_proxy)
        self.proxy_panel.Hide()
        
        self.bottom_panel = wx.Panel(id=wxID_WIZARD_S3BOTTOM_PANEL,
            name=u'bottom_panel', parent=self,
            size=wx.Size(590, 50), style=wx.NO_BORDER)
        self.bottom_panel.SetBackgroundColour(wx.Colour(240, 240, 240))        

        self.bt_exit = wx.lib.buttons.GenBitmapTextButton(
            bitmap=wx.Bitmap(const.DIR + 'icons' + os.sep + 'arrow-right.png'),
            id=wxID_WIZARD_S3BT_EXIT, label=u' Exit',
            name=u'bt_exit', parent=self.bottom_panel, pos=wx.Point(0, 0),
            size=wx.Size(240, 50), style=wx.SIMPLE_BORDER)
        self.bt_exit.SetBackgroundColour(wx.Colour(212, 212, 255))
        self.bt_exit.SetFont(wx.Font(const.SIZE+4, wx.SWISS, wx.NORMAL, wx.BOLD,
            False, const.FONT_FACE))
        self.bt_exit.SetForegroundColour(wx.Colour(60, 60, 60))
        self.bt_exit.SetHelpText(u'Exit')
        self.bt_exit.Bind(wx.EVT_BUTTON, self.close_me)

        self.bt_retry = wx.lib.buttons.GenBitmapTextButton(
            bitmap=wx.Bitmap(const.DIR + 'icons' + os.sep + 'arrow-right.png'),
            id=wxID_WIZARD_S3BT_RETRY, label=u' Try again',
            name=u'bt_retry', parent=self.bottom_panel, pos=wx.Point(0, 0),
            size=wx.Size(240, 50), style=wx.SIMPLE_BORDER)
        self.bt_retry.SetBackgroundColour(wx.Colour(212, 212, 255))
        self.bt_retry.SetFont(wx.Font(const.SIZE+4, wx.SWISS, wx.NORMAL,
            wx.BOLD, False, const.FONT_FACE))
        self.bt_retry.SetForegroundColour(wx.Colour(60, 60, 60))
        self.bt_retry.SetHelpText(u'Try again')
        self.bt_retry.Bind(wx.EVT_BUTTON, self.retry)
        self.bt_retry.Hide()

        sizer_all = wx.BoxSizer(wx.VERTICAL)
        sizer_all.Add(self.top_panel, 1,
            wx.ALIGN_CENTER_HORIZONTAL | wx.EXPAND | wx.ALL, border = 5)
        sizer_all.Add(self.proxy_panel, 0,
            wx.ALIGN_CENTER_HORIZONTAL | wx.CENTER | wx.ALL, border = 5)            
        sizer_all.Add(self.bottom_panel, 0,
            wx.ALIGN_CENTER_HORIZONTAL | wx.CENTER | wx.ALL, border = 5)
        self.SetSizer(sizer_all)
        self.Layout()

    def show_error(self):
        self.thanks_panel.Hide()
        self.bt_exit.Hide()
        self.error_panel.Show()
        self.bt_retry.Show()
        self.lb_link.Hide()
        self.proxy_panel.Show()
        self.top_panel.Layout()
        if const.USE_PROXY:
            self.lb_proxy_server.Enable()
            self.lb_proxy_port.Enable()
            self.txt_proxy_port.Enable()
            self.txt_proxy_server.Enable()
        else:
            self.lb_proxy_server.Disable()
            self.lb_proxy_port.Disable()
            self.txt_proxy_port.Disable()
            self.txt_proxy_server.Disable()
        self.cb_proxy.SetValue(const.USE_PROXY)
        self.txt_proxy_server.SetValue(const.PROXY_SERVER)
        self.txt_proxy_port.SetValue(const.PROXY_PORT)
        self.Layout()

    def set_link(self, uid):
        self.lb_link.SetURL(
            u"http://www.simpleweb.org/dropbox/result/?uid=" + uid)
        self.lb_link.Show()
        self.Layout()

    def retry(self, event):
        const.USE_PROXY = self.cb_proxy.IsChecked()
        const.PROXY_SERVER = self.txt_proxy_server.GetValue()
        const.PROXY_PORT = self.txt_proxy_port.GetValue()      
        self.parent.wizard_3.Hide()
        self.parent.wizard_2.Show()
        self.parent.Layout()
        self.parent.send_it(event)
        self.thanks_panel.Show()
        self.bt_exit.Show()
        self.error_panel.Hide()
        self.bt_retry.Hide()
        self.proxy_panel.Hide()
        self.lb_link.Show()
        self.top_panel.Layout()
        self.Layout()

    def close_me(self, event):
        self.parent.onClose(event)

    def __init__(self, parent):
        self._init_ctrls(parent)
        
    def cb_proxy_cli_text(self, event):
        wizard.cb_proxy_cli_text(self)

    def cb_proxy_cli(self, event):
        wizard.cb_proxy_cli(self)
        