#!/usr/bin/python
# -*- coding: utf-8 -*-

import os

import wx
import const

def create(parent):
    return Wizard_log(parent)

MSG1 = u"This is what will be sent:"

[
    wxID_WIZARD_LOG, wxID_WIZARD_LOGTOP_PANEL, wxID_WIZARD_LOGLB_BYTES,
    wxID_WIZARD_LOGTXT_PANEL, wxID_WIZARD_LOGBT_CLOSE
] = [wx.NewId() for _init_ctrls in range(5)]

class Wizard_log(wx.Dialog):
    def _init_ctrls(self, prnt):

        wx.Dialog.__init__(self, id=wxID_WIZARD_LOG, name=u'Wizard_log',
            parent=prnt, pos=wx.Point(180, 140), size=wx.Size(600, 380),
            style=wx.MINIMIZE_BOX | wx.MAXIMIZE_BOX | wx.CLOSE_BOX |
                wx.RESIZE_BORDER | wx.SYSTEM_MENU | wx.CAPTION,
            title=u'Dropbox crawler')
        self.SetIcon(
            wx.Icon(const.DIR + 'icons' +
                    os.sep + 'preferences-desktop-accessibility.png',
                    wx.BITMAP_TYPE_PNG))
        self.SetBackgroundColour(wx.Colour(240, 240, 240))
        self.SetClientSize(wx.Size(600, 380))

        self.top_panel = wx.Panel(id=wxID_WIZARD_LOGTOP_PANEL,
            name=u'top_panel',
            parent=self, pos=wx.Point(5, 5), size=wx.Size(585, 315),
            style=wx.NO_BORDER)
        self.top_panel.SetBackgroundColour(wx.Colour(240, 240, 240))

        self.lb_top = wx.StaticText(id=wxID_WIZARD_LOGLB_BYTES,
            label = MSG1, name=u'lb_top', parent=self.top_panel,
            pos=wx.Point(0, 0), size=wx.Size(500, 20), style=0)
        self.lb_top.SetFont(const.FONT_B)
        self.lb_top.SetForegroundColour(wx.Colour(0, 51, 102))

        self.txt_log = wx.TextCtrl(id=wxID_WIZARD_LOGTXT_PANEL, name=u'txt_log',
            parent=self.top_panel, pos=wx.Point(0, 20),
            size=wx.Size(585, 285),
            style=wx.TE_MULTILINE | wx.TE_RICH |
                wx.TE_DONTWRAP | wx.TE_READONLY, value=u'')
        self.txt_log.SetEditable(False)

        self.bt_close = wx.lib.buttons.GenBitmapTextButton(
            bitmap=wx.Bitmap(const.DIR + 'icons' + os.sep + 'window-close.png'),
            id=wxID_WIZARD_LOGBT_CLOSE, label=u' Close',
            name=u'bt_close', parent=self, pos=wx.Point(200, 325),
            size=wx.Size(200, 45), style=wx.SIMPLE_BORDER)
        self.bt_close.SetBackgroundColour(wx.Colour(212, 212, 255))
        self.bt_close.SetFont(const.FONT_B)
        self.bt_close.SetForegroundColour(wx.Colour(60, 60, 60))
        self.bt_close.Bind(wx.EVT_BUTTON, self.close_me)

        sizer_top = wx.BoxSizer(wx.VERTICAL)
        sizer_top.Add(self.lb_top, 0,
            wx.ALIGN_TOP | wx.TOP | wx.LEFT, border = 5)
        sizer_top.Add(self.txt_log, 1,
            wx.ALIGN_BOTTOM | wx.ALIGN_CENTER | wx.EXPAND | wx.ALL, border = 5)
        self.top_panel.SetSizer(sizer_top)

        sizer_all = wx.BoxSizer(wx.VERTICAL)
        sizer_all.Add(self.top_panel, 1,
            wx.ALIGN_TOP | wx.EXPAND | wx.ALL, border = 5)
        sizer_all.Add(self.bt_close, 0,
            wx.ALIGN_BOTTOM | wx.ALIGN_CENTER | wx.ALL, border = 5)
        self.SetSizer(sizer_all)
        self.Layout()

    def close_me(self, event):
        self.Destroy()

    def __init__(self, parent):
        self._init_ctrls(parent)
